--[[
-- This is a total rip of someone elses code (at the time of checkin), and I do
-- not intend to fix it much. Maybe I'll fix some things, but we'll see.
--
-- If you want to start hacking on this, be my guest, but don't add crazy-ass
-- shit like enemy cast bars and stuff, I'll just kick your nuts and revert.
--
-- KOREANS SHOULD ALSO READ THIS WARNING.
--
-- -- Rabbit.
--
--]]

local Default				= {
	CastingBar			= {
		width 			= 255,
		height			= 25,
		edgeFile		= "Default",
		texture			= "Otravi",
		icon			= "Left",
		timeSize		= 12,
		spellSize		= 10,
		delaySize		= 14,
	},
	MirrorBar			= {
		width 			= 255,
		height			= 25,
		edgeFile		= "Default",
		texture			= "Otravi",
		timeSize		= 12,
		spellSize		= 10,
		delaySize		= 14,
	},
	Colors				= {
		Complete		= {r=0, g=1, b=0},
		Casting			= {r=1, g=.7, b=0},
		Channel		= {r=.3, g=.3, b=1},
		Failed			= {r=1, g=0, b=0},
	},
	Mirror				= {
		EXHAUSTION 	= {r=1, g=.9, b=0},
		BREATH			= {r=0, g=.5, b=1},
		DEATH			= {r=0, g=.7, b=1},
		FEIGNDEATH	= {r=1, g=.7, b=1}
	},
	Pos = {}
}

local Borders 		= {
	["Default"] 		= "Interface\\Tooltips\\UI-Tooltip-Border",
	["None"] 		= ""
}

CBRipoff = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDebug-2.0", "AceDB-2.0", "AceConsole-2.0")
local L = AceLibrary("AceLocale-2.2"):new("CBRipoff")

function CBRipoff:OnInitialize()
	self.Borders = Borders
	
	self.surface = AceLibrary("Surface-1.0")
	self.surface:Register("Otravi", "Interface\\AddOns\\CBRipoff\\textures\\CBRipoff")
	
	self.consoleOptions = {
		type = 'group',
		args = {
			lock = {
				name = L["Lock"], type = 'toggle', order = 1,
				desc = L["Lock/Unlock the casting bar."],
				get = function() return self.db.profile.lock end,
				set = function() self.db.profile.lock = not self.db.profile.lock end
			}, 
			castingbar = {
				name = L["Casting Bar"], type = 'group', order = 2,
				desc = L["Set Casting Bar"], 
				args = {
					width = {
						name = L["Width"], type = 'range', min = 10, max = 500, step = 1,
						desc = L["Set the width of the casting bar."],
						get = function() return self.db.profile.CastingBar.width end,
						set = function(v)
							self.db.profile.CastingBar.width = v
							self:Layout("CastingBar")
						end
					},
					height = {
						name = L["Height"], type = 'range', min = 5, max = 50, step = 1,
						desc = L["Set the height of the casting bar."],
						get = function() return self.db.profile.CastingBar.height end,
						set = function(v)
							self.db.profile.CastingBar.height = v
							self:Layout("CastingBar")
						end
					},
					border = {
						name = L["Border"], type = 'text',
						desc = L["Toggle the border."],
						get = function() return self.db.profile.CastingBar.edgeFile end,
						set = function(v)
							self.db.profile.CastingBar.edgeFile = v
							self:Layout("CastingBar")
						end,
						validate = {["Default"] = L["Default"],["None"] = L["None"]}
					},
					texture = {
						name = L["Texture"], type = 'text',
						desc = L["Toggle the texture."],
						get = function() return self.db.profile.CastingBar.texture end,
						set = function(v)
							self.db.profile.CastingBar.texture = v
							self:Layout("CastingBar")
						end,
						validate = self.surface:List()
					},
					icon = {
						name = L["Icon"], type ='text',
						desc = L["Toggle the spell icon."],
						get = function() return self.db.profile.CastingBar.icon end,
						set = function(v) 
							self.db.profile.CastingBar.icon = v
							self:Layout("CastingBar")
						end,
						validate = {["Left"] = L["Left"], ["Right"] = L["Right"], ["None"] = L["None"]}
					},
					font = {
						name = L["Font"], type = 'group',
						desc = L["Set the font size of different elements."],
						args = {
							spell = {
								name = L["Spell"], type = 'range', min = 6, max = 32, step = 1,
								desc = L["Set the font size on the spellname, when casting."],
								get = function() return self.db.profile.CastingBar.spellSize end,
								set = function(v)
									self.db.profile.CastingBar.spellSize = v
									self:Layout("CastingBar")
								end
							},
							time = {
								name = L["Time"], type = 'range', min = 6, max = 32, step = 1,
								desc = L["Set the font size on the spell time."],
								get = function() return self.db.profile.CastingBar.timeSize end,
								set = function(v)
									self.db.profile.CastingBar.timeSize = v
									self:Layout("CastingBar")
								end
							},
							delay = {
								name = L["Delay"], type = 'range', min = 6, max = 32, step = 1,
								desc = L["Set the font size on the delay time."],
								get = function() return self.db.profile.CastingBar.delaySize end,
								set = function(v)
									self.db.profile.CastingBar.delaySize = v
									self:Layout("CastingBar")
								end
							}
						}
					}
				}
			},
			mirrorbar = {
				name = L["Mirror Bar"], type = 'group', order = 3,
				desc = L["Set Mirror Bar"],
				args = {
					width = {
						name = L["Width"], type = 'range', min = 10, max = 500, step = 1,
						desc = L["Set the width of the mirror bar."],
						get = function() return self.db.profile.MirrorBar.width end,
						set = function(v)
							self.db.profile.MirrorBar.width = v
							self:Layout("BREATH", "MirrorBar")
							self:Layout("EXHAUSTION", "MirrorBar")
							self:Layout("FEIGNDEATH", "MirrorBar")
						end
					},
					height = {
						name = L["Height"], type = 'range', min = 5, max = 50, step = 1,
						desc = L["Set the height of the mirror bar."],
						get = function() return self.db.profile.MirrorBar.height end,
						set = function(v)
							self.db.profile.MirrorBar.height = v
							self:Layout("BREATH", "MirrorBar")
							self:Layout("EXHAUSTION", "MirrorBar")
							self:Layout("FEIGNDEATH", "MirrorBar")
						end
					},
					border = {
						name = L["Border"], type = 'text',
						desc = L["Toggle the border."],
						get = function() return self.db.profile.MirrorBar.edgeFile end,
						set = function(v)
							self.db.profile.MirrorBar.edgeFile = v
							self:Layout("BREATH", "MirrorBar")
							self:Layout("EXHAUSTION", "MirrorBar")
							self:Layout("FEIGNDEATH", "MirrorBar")
						end,
						validate = {["Default"] = L["Default"],["None"] = L["None"]}
					},
					texture = {
						name = L["Texture"], type = 'text',
						desc = L["Toggle the texture."],
						get = function() return self.db.profile.MirrorBar.texture end,
						set = function(v)
							self.db.profile.MirrorBar.texture = v
							self:Layout("BREATH", "MirrorBar")
							self:Layout("EXHAUSTION", "MirrorBar")
							self:Layout("FEIGNDEATH", "MirrorBar")
						end,
						validate = self.surface:List()
					},
					font = {
						name = L["Font"], type = 'group',
						desc = L["Set the font size of different elements."],
						args = {
							spell = {
								name = L["Spell"], type = 'range', min = 6, max = 32, step = 1,
								desc = L["Set the font size on the spellname, when shown."],
								get = function() return self.db.profile.MirrorBar.spellSize end,
								set = function(v)
									self.db.profile.MirrorBar.spellSize = v
									self:Layout("MirrorBar")
								end
							},
							time = {
								name = L["Time"], type = 'range', min = 6, max = 32, step = 1,
								desc = L["Set the font size on the spell time."],
								get = function() return self.db.profile.MirrorBar.timeSize end,
								set = function(v)
									self.db.profile.MirrorBar.timeSize = v
									self:Layout("BREATH", "MirrorBar")
									self:Layout("EXHAUSTION", "MirrorBar")
									self:Layout("FEIGNDEATH", "MirrorBar")
								end
							},
							delay = {
								name = L["Delay"], type = 'range', min = 6, max = 32, step = 1,
								desc = L["Set the font size on the delay time."],
								get = function() return self.db.profile.MirrorBar.delaySize end,
								set = function(v)
									self.db.profile.MirrorBar.delaySize = v
									self:Layout("BREATH", "MirrorBar")
									self:Layout("EXHAUSTION", "MirrorBar")
									self:Layout("FEIGNDEATH", "MirrorBar")
								end
							}
						}
					}
				}
			},
			colors = {
				name = L["Colors"], type = 'group', order = 4,
				desc = L["Set the bar colors."],
				args = {
					spell = {
						name = L["Spell"], type = 'color',
						desc = L["Sets the color of the casting bars on spells."],
						get = function()
							local v = self.db.profile.Colors.Casting
							return v.r,v.g,v.b
						end,
						set = function(r,g,b) self.db.profile.Colors.Casting = {r=r,g=g,b=b} end
					},
					success = {
						name = L["Success"], type = 'color',
						desc = L["Sets the color of the casting bars on succsessful casts."],
						get = function()
							local v = self.db.profile.Colors.Complete
							return v.r,v.g,v.b
						end,
						set = function(r,g,b) self.db.profile.Colors.Complete = {r=r,g=g,b=b} end
					},
					channel = {
						name = L["Channel"], type = 'color',
						desc = L["Sets the color of the casting bars while channeling."],
						get = function()
							local v = self.db.profile.Colors.Channel
							return v.r,v.g,v.b
						end,
						set = function(r,g,b) self.db.profile.Colors.Channel = {r=r,g=g,b=b} end
					},
					failed = {
						name = L["Failed"], type = 'color',
						desc = L["Sets the color of the casting bars on failed casts."],
						get = function()
							local v = self.db.profile.Colors.Failed
							return v.r,v.g,v.b
						end,
						set = function(r,g,b) self.db.profile.Colors.Failed = {r=r,g=g,b=b} end
					}
				}
			}
		}
	}
	
	self:RegisterDB("CBRipoffDB")
	self:RegisterDefaults('profile', Default)
	
	self:RegisterChatCommand({ "/CBRipoff", "/cbr"}, self.consoleOptions)
	
	self.frames = {}
	self:SetDebugging(false)
end

function CBRipoff:OnEnable()
	self:Events()
	self:HideBlizzCB()

	self:CreateFramework("CastingBar", "CBRipoffFrame")
	self:CreateFramework("BREATH", "CBRipoffMirror1", "MirrorBar")
	self:CreateFramework("EXHAUSTION","CBRipoffMirror2", "MirrorBar")
	self:CreateFramework("FEIGNDEATH","CBRipoffMirror3", "MirrorBar")
end

function CBRipoff:OnDisable()
	self:ShowBlizzCB()
	UIParent:RegisterEvent("MIRROR_TIMER_START")
end

function CBRipoff:Events()
	--[[ New events:
		* UNIT_SPELLCAST_SENT,
			a1: "player"
			a2: spell
			a3: rank
			a4: target
		* UNIT_SPELLCAST_SUCCEEDED
			a1: "player"
			a2: spell
			a3: rank
	]]
	
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED", "CastSucceeded")
	
	--[[  Old events
	]]
	self:RegisterEvent("UNIT_SPELLCAST_START", "CastStart")
	self:RegisterEvent("UNIT_SPELLCAST_FAILED", "CastFailed")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED", "CastFailed")
	self:RegisterEvent("UNIT_SPELLCAST_DELAYED", "CastDelayed")
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START", "ChannelStart")
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE", "ChannelUpdate")
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP", "ChannelStop")
	
	self:RegisterEvent("MIRROR_TIMER_START")
	self:RegisterEvent("MIRROR_TIMER_PAUSE")
	self:RegisterEvent("MIRROR_TIMER_STOP")
	
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	
	UIParent:UnregisterEvent("MIRROR_TIMER_START")
end

function CBRipoff:updatePositions(n)
	if(self.db.profile.Pos[n]) then
		local x, y = strsplit(" ", self.db.profile.Pos[n])
		local s = self.frames[n]:GetEffectiveScale()
		
		self.frames[n]:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x/s, y/s)
	elseif(self.frames[n]) then
		self.frames[n]:ClearAllPoints()
		self.frames[n]:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	end
end

function CBRipoff:savePosition()
	local f = self.frames[this.name]
	local x,y = f:GetLeft(), f:GetTop()
	local s = f:GetEffectiveScale()
	
	x,y = x*s,y*s
	
	self.db.profile.Pos[this.name] = strjoin(" ", x, y)
end

